AchievementPopped = class(Turbine.UI.Control)
function AchievementPopped:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Word of Exaltation"] = true,
        ["Exaltation on Blortles"] = true,
        ["Armour of The Elements"] = true,

        ["Legend of Helm Hammerhand"] = true,
        ["Song of Helm Hammerhand"] = true,
        ["Improved Gift of the Hammerhand"] = true,
    }

    self.playerName = Turbine.Gameplay.LocalPlayer.GetInstance():GetName()

    self.handler = handler

    self:SetCallbacks()

end

function AchievementPopped:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then

            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Popped", "Usage of a bubble skill", 0x410FA925)
            end))
        end
    end

    self.benefitCallback = AddCallback(ChatEventHandler, "PlayerBenefit", function(args)
        if args.Source == self.playerName and self.skillList[args.SkillName] then
            self.handler:Fail("Popped", "Usage of a bubble skill", 0x410FA925)
        end
    end)
end

function AchievementPopped:Unload()
    RemoveCallback(ChatEventHandler, "PlayerBenefit", self.benefitCallback)
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
    RemoveCallback(ChatEventHandler, "PlayerBenefit", self.benefitCallback)
end

function AchievementPopped:Refresh()
    self:Unload()
    self:SetCallbacks()
end